#!/bin/sh
#------------------------------------------------------------------------------
# part of the webconf-package for eisfair
# install script
# $Id: install.sh,v 1.2 2004/02/08 13:03:12 chriswue Exp $
# (c) 2002-2004 by Christian Wrdig (eisfair@chriswue.de)
#------------------------------------------------------------------------------

passwd1="/var/config/www/.htpasswd"
passwd2="/var/config/www/cgi-bin/.htpasswd"
config="/etc/config.d/webconf"
oldconfig="/etc/config.d/webconf.old"

certconf="/usr/local/webconf/mini_httpd.cnf"
cert="/var/config/mini_httpd.pem"
tmp="/tmp/.certcnf.$$"
fqdn=`hostname`

takeover_old_config() {
   . $oldconfig
   ws=${START_WEBCONF:-yes}
   ws=${WEBCONF_START:-$ws}
   wp=${WEBCONF_PORT:-3001}
   wc=${WEBCONF_CSS:-default}
   wv=${WEBCONF_VERBOSE:-no}
   {      
      echo "#------------------------------------------------------------------------------"
      echo "# part of the webconf-package for eisfair"
      echo "# configfile"
      echo "# last update: 2003/11/06"
      echo "# (c) 2002-2003 by Christian Wrdig (eisfair@chriswue.de)"
      echo "#------------------------------------------------------------------------------"
      echo ""
      echo "# complete doku: /usr/share/doc/webconf/webconf.txt"
      echo ""
      echo "#------------------------------------------------------------------------------"
      echo "# misc"
      echo "#------------------------------------------------------------------------------"
      echo ""
      echo "START_WEBCONF='$ws'                # start mini_httpd at boottime?"
      echo "WEBCONF_PORT='$wp'               # service port"
      echo "WEBCONF_CSS='$wc'             # CSS to use"
      echo "WEBCONF_VERBOSE='$wv'              # print additional information in formulars"
   } > $config
}

# create Links for Startup
cd /etc/rc2.d/
ln -sf ../init.d/webconf S90webconf
ln -sf ../init.d/webconf K10webconf

# create user-entry
grep "^root" /etc/shadow | cut -d ':' -f 2 > /etc/webconf.conf
chown root /etc/webconf.conf
chgrp root /etc/webconf.conf
chmod 600 /etc/webconf.conf
chown root /var/config/tmp
chgrp root /var/config/tmp
chmod 700 /var/config/tmp

rm -f `ls -A /var/config/tmp/`

# create menu-entries
/var/install/bin/add-menu /var/install/menu/setup.services.menu \
                          /var/install/bin/setup.services.webconf \
                          "Webconf"

if [ -f $cert ]; then
   echo "keeping old certificate"
else
   # set fqdn
   sed -e "s/\(0.commonName_default            = \).*/\1 $fqdn/" $certconf > $tmp
   cp $tmp $certcnf
   rm -f $tmp

   # create certificate
   echo "The ssl-certificate for the web-configuration is now created"
   echo
   /usr/bin/openssl req -new -x509 -days 365 -nodes -batch \
      -config $certconf -out $cert -keyout $cert
   echo
fi

chmod 600 $cert
echo "check certificate settings"
echo
/usr/bin/openssl x509 -subject -dates -fingerprint -noout -in $cert

if [ -f $oldconfig ]; then
   echo "take over old config values"
   takeover_old_config
   echo "restoring old .htpasswd"
   cp $passwd1.old $passwd1
   cp $passwd2.old $passwd2
   rm -f $oldconfig $passwd1.old $passwd2.old
fi

/var/install/config.d/webconf
